require "amrita2/template"
require "amrita2/js"
include Amrita2

# template for the JavaScript
t = JS::TemplateText.new <<-END
   <div>
      <h1 id='title'>title will be inserted here</h1>
      <p>This paragraph is static part</p>
      <p id='body'>body text will be inserted here</p>
      <p id='now'></p>
   </div>
END

# compiling the template to JavaScript functions
js = JS::CodeGenerator.new
t.js_template('tmpl', js)
jssrc = Amrita2::JS::RUNTIME_SRC + js.results.join("\n") 

# template for the document
tmpl = TemplateText.new <<END
<html>
<head>
<title>Amrita2 JS Hello</title>
<script id='script' language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">

// This will be removed until release
function debug(s) {
}

// HTTP accessing function
/* from http://www.peej.co.uk/articles/rich-user-experience.html */
function getHTTPObject() {
  var xmlhttp;
  try {  
    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (E) {
      xmlhttp = false; 
    } 
  } 
  if (!xmlhttp) { 
    if(typeof XMLHttpRequest != 'undefined') {
      try {
        xmlhttp = new XMLHttpRequest(); 
      } catch (e) {
        xmlhttp = false; 
      } 
    }
  }
  return xmlhttp; 
}

// Use the function compiled from from the template
function expand_template(datasrc)
{ 
  // get the element to which the template will be inserted
  var e = document.getElementById('output') ;
  while (e.hasChildNodes()) {
      e.removeChild(e.firstChild) ;
  }
  // make a template object
  var t = new tmpl() ;
  // get data
  eval(datasrc) ;
  // add changing data for demo
  var d = new Date()
  data.now = d.getMinutes() + ":" + d.getSeconds() ;
  // mix the data and the template
  t.expand(e, data) ;

}

/* 
  json_ajax_data.txt is a file contains a 
  JavaScript source generating a data.

  data = {
    'title': 'Ajax with Amrita2 ',
    'body':  'This is a text from the data source.'
  }

*/

function getData() { 
  var http = getHTTPObject(); 
  http.open("GET", "json_ajax_data.txt", true); 
  http.onreadystatechange = function() {
    if (http.readyState == 4) {
      expand_template(http.responseText); 
      setTimeout("getData()", 3000) ;
    } 
  } 
  http.send(null);
}

</script>
</head>

<body onload='getData()'>
<div id='output' />
</body>
</html>
END

# expand the document statically
tmpl.expand(STDOUT, :script => Amrita2::SanitizedString[jssrc], :output=>true)
