require 'amrita2/template'
include Amrita2
include Amrita2::Core
t = TemplateFile.new("template.html") do
  Amrita2::define_template_spec(:key_attr_name=> :id) do
    dynamic_element(:head, :matcher=>TagMatcher.new(:head)) do 
      dynamic_element(:title, :matcher=>TagMatcher.new(:title))
    end
    dynamic_element(:title) 
    dynamic_element(:rightbar, :matcher => Amrita2::Core::AttrMatcher.new("class", "rightbar")) do
      dynamic_element(:rightbaritem, :matcher => Amrita2::Core::AttrMatcher.new("class", "rightbaritem")) do
        dynamic_element(:rightbartitle, :matcher => Amrita2::Core::AttrMatcher.new("class", "rightbartitle")) # Language 
        dynamic_element(:rmenulist, :matcher=>TagMatcher.new(:ul)) do 
          dynamic_element(:item, :matcher=>TagMatcher.new(:li)) do 
            dynamic_element(:a, :matcher=>TagMatcher.new(:a), :replace_attr=>true)
          end
          dummy_element(:item, :matcher=>TagMatcher.new(:li))
        end
      end
      dummy_element(:rightbaritem, :matcher => Amrita2::Core::AttrMatcher.new("class", "rightbaritem"))
      dummy_element(:rightbaritem, :matcher => Amrita2::Core::AttrMatcher.new("class", "rightbaritem"))
    end
    dynamic_element(:main, :matcher => Amrita2::Core::AttrMatcher.new("class", "main")) do
      dynamic_element(:day, :matcher => Amrita2::Core::AttrMatcher.new("class", "day")) do
        dynamic_element(:date, :matcher => Amrita2::Core::AttrMatcher.new("class", "date")) # <a href='http://www.r 
        dynamic_element(:title, :matcher => Amrita2::Core::AttrMatcher.new("class", "title")) # Ruby Weekly News 
        dynamic_element(:body, :matcher => Amrita2::Core::AttrMatcher.new("class", "body")) do
          dynamic_element(:section, :matcher => Amrita2::Core::AttrMatcher.new("class", "section")) do
            dynamic_element(:corres, :matcher => Amrita2::Core::AttrMatcher.new("class", "corres")) # by chad 
            dynamic_element(:p, :matcher => TagMatcher.new(:p))
            dummy_element(:p, :matcher => TagMatcher.new(:p))
          end
          dynamic_element(:lm, :matcher => Amrita2::Core::AttrMatcher.new("class", "lm")) # Last update on Februa 
        end
        dynamic_element(:comment, :matcher => Amrita2::Core::AttrMatcher.new("class", "comment")) #  
      end
      dummy_element(:day, :matcher => Amrita2::Core::AttrMatcher.new("class", "day"))
      dummy_element(:day, :matcher => Amrita2::Core::AttrMatcher.new("class", "day"))
    end
    dynamic_element(:sidebar, :matcher => Amrita2::Core::AttrMatcher.new("class", "sidebar")) do
      dynamic_element(:menu, :matcher => Amrita2::Core::AttrMatcher.new("class", "menu")) do # <a href='index.html'> 
        dynamic_element(:a, :matcher=>TagMatcher.new(:a))
      end
      dynamic_element(:smenulist, :matcher=>TagMatcher.new(:ul)) do 
        dynamic_element(:item, :matcher=>TagMatcher.new(:li)) do 
          dynamic_element(:a, :matcher=>TagMatcher.new(:a), :replace_attr=>true)
        end
      end
    end
    dynamic_element(:footer1, :matcher => Amrita2::Core::AttrMatcher.new("class", "footer")) do
      dynamic_element(:written_by, :matcher=>TagMatcher.new(:a), :replace_attr=>true)
    end
    dynamic_element(:footer2, :matcher => Amrita2::Core::AttrMatcher.new("class", "footer")) do 
      dynamic_element(:generated_by, :matcher=>TagMatcher.new(:a), :replace_attr=>true)
    end
  end

end

class MenuList
  def initialize
    @items = [
      ["Amrita", "http://amrita.sourceforge.jp/"],
      ["Amrita2", "http://amrita2.rubyforge.org/"],
      ["Ruby", "http://www.ruby-lang.org/"],
    ]
  end

  def item(m)
    @items.each do |name, url|
      m.item do |mitem|
        mitem.a(name, :href=>url)
      end
    end
  end
end

data = 
  {
  :head=> { :title =>'Amrita2 Reverse Generated Page'},
  :title => "Amrita2: Web Programmer's Best Friend'",
  :main=>
    {
    :day=>
      [
      {:date=>
          Amrita2::SanitizedString["<a href='http://www.ruby-lang.org/en/20050220.html'>#</a>"],
        :title=>"Amrita2 initial release",
        :body=>
          {:lm=>" Last update on February 20, 2005\n          15:03\n        ",
          :section=>{
            :corres=>Amrita2::SanitizedString["by taku"],
            :p=> "Amrita2 was released."
          }},
        :comment=>Amrita2::SanitizedString[""]},
      {:date=>
          Amrita2::SanitizedString["<a href='http://www.ruby-lang.org/en/20050220.html'>#</a>"],
        :title=>"Amrita2 reverse spec generation",
        :body=>
          {:lm=>" Last update on February 20, 2005\n          15:03\n        ",
          :section=>{
            :corres=>Amrita2::SanitizedString["by taku"],
            :p=>[
              "Amrita2 has a kind of reverse enegineering feature. It can generate a ruby script from HTML file. Using this, you can make the requested dynamic page from a static HTML file",
              "This page was generated from www.ruby-lang.org using this feature"
            ]
          }
        },
        :comment=>Amrita2::SanitizedString[""]},
    ]},
  :sidebar=> { 
    :menu => { :a=>"Amrita2 Top"},
    :smenulist => MenuList.new 
  },
  :rightbar=>
    {:rightbaritem=>
      [
      {
        :rightbartitle=>Amrita2::SanitizedString["\n        Language\n      "],
        :rmenulist => MenuList.new
      },
    ]
  },
  :footer1=> { :written_by => "Taku Nakajima" },
  :footer2=> { :generated_by => "Amrita2" }
}

t.expand(STDOUT, data)
